VirtuousAI
Reference

Workspaces

List Workspaces

GET
/api/v1/workspaces

Query Parameters

status?string
Default"active"
Value in"active" | "archived"
tag?array<>|

Filter by tag name(s)

tag_id?array<>|

Filter by tag id(s)

tag_match?string
Default"any"
Value in"any" | "all"

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces"
{
  "items": [
    {
      "backingOwnerTaskSlug": "string",
      "backingRowIdentityColumns": [
        "string"
      ],
      "backingSourceType": "string",
      "backingTableName": "string",
      "backingTableScope": "string",
      "backingWorkspaceKey": "string",
      "createdAt": "2019-08-24T14:15:22Z",
      "description": "string",
      "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
      "isShared": false,
      "mode": "snapshot",
      "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
      "rendererConfig": {},
      "rowIdColumn": "string",
      "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
      "shareRecipients": [
        {
          "email": "string",
          "firstName": "string",
          "id": "string",
          "lastName": "string",
          "profilePictureUrl": "string"
        }
      ],
      "sharedBy": {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      },
      "status": "active",
      "storageKey": "string",
      "title": "string",
      "updatedAt": "2019-08-24T14:15:22Z",
      "viewerAccess": "owner"
    }
  ]
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Create Workspace

POST
/api/v1/workspaces

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

artifactId?|
backingTableName?|
backingTableScope?|
description?|
mode?string
Default"snapshot"
Value in"snapshot" | "operational"
rowIdColumn?|
taskBindings?array<>
title*string
Length1 <= length <= 255
version?|

Response Body

application/json

application/json

curl -X POST "https://loading/api/v1/workspaces" \  -H "Content-Type: application/json" \  -d '{    "title": "string"  }'
{
  "boundTasks": [
    {
      "bindingId": "5fecb7b6-229e-4247-b81d-92842fd7d9b7",
      "description": "string",
      "displayName": "string",
      "lifecycle": "draft",
      "mutatesWorkspace": true,
      "name": "string",
      "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8"
    }
  ],
  "warnings": [
    {
      "code": "string",
      "effectiveRowIdColumn": "string",
      "message": "string",
      "requestedRowIdColumn": "string"
    }
  ],
  "workspace": {
    "backingOwnerTaskSlug": "string",
    "backingRowIdentityColumns": [
      "string"
    ],
    "backingSourceType": "string",
    "backingTableName": "string",
    "backingTableScope": "string",
    "backingWorkspaceKey": "string",
    "createdAt": "2019-08-24T14:15:22Z",
    "description": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "isShared": false,
    "mode": "snapshot",
    "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
    "rendererConfig": {},
    "rowIdColumn": "string",
    "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
    "shareRecipients": [
      {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      }
    ],
    "sharedBy": {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    },
    "status": "active",
    "storageKey": "string",
    "title": "string",
    "updatedAt": "2019-08-24T14:15:22Z",
    "viewerAccess": "owner"
  }
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

List Shared Workspaces

GET
/api/v1/workspaces/shared

Query Parameters

limit?integer
Default25
Range1 <= value <= 100
offset?integer
Default0
Range0 <= value

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/shared"
{
  "hasNext": true,
  "items": [
    {
      "backingOwnerTaskSlug": "string",
      "backingRowIdentityColumns": [
        "string"
      ],
      "backingSourceType": "string",
      "backingTableName": "string",
      "backingTableScope": "string",
      "backingWorkspaceKey": "string",
      "createdAt": "2019-08-24T14:15:22Z",
      "description": "string",
      "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
      "isShared": false,
      "mode": "snapshot",
      "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
      "rendererConfig": {},
      "rowIdColumn": "string",
      "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
      "shareRecipients": [
        {
          "email": "string",
          "firstName": "string",
          "id": "string",
          "lastName": "string",
          "profilePictureUrl": "string"
        }
      ],
      "sharedBy": {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      },
      "status": "active",
      "storageKey": "string",
      "title": "string",
      "updatedAt": "2019-08-24T14:15:22Z",
      "viewerAccess": "owner"
    }
  ],
  "limit": 0,
  "offset": 0,
  "total": 0
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

List Workspace Table Candidates

GET
/api/v1/workspaces/table-candidates

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/table-candidates"
{
  "items": [
    {
      "canOpenWorkspace": true,
      "canWrite": false,
      "lastWriteAt": "2019-08-24T14:15:22Z",
      "logicalTableName": "string",
      "ownerTaskSlug": "string",
      "ownerWorkspaceKey": "string",
      "primaryKeyColumns": [
        "string"
      ],
      "readOnlyReason": "string",
      "rowCount": 0,
      "scope": "task",
      "sourceType": "string",
      "tableName": "string"
    }
  ]
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Get Workspace

GET
/api/v1/workspaces/{workspace_id}

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08"
{
  "boundTasks": [
    {
      "bindingId": "5fecb7b6-229e-4247-b81d-92842fd7d9b7",
      "description": "string",
      "displayName": "string",
      "lifecycle": "draft",
      "mutatesWorkspace": true,
      "name": "string",
      "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8"
    }
  ],
  "workspace": {
    "backingOwnerTaskSlug": "string",
    "backingRowIdentityColumns": [
      "string"
    ],
    "backingSourceType": "string",
    "backingTableName": "string",
    "backingTableScope": "string",
    "backingWorkspaceKey": "string",
    "createdAt": "2019-08-24T14:15:22Z",
    "description": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "isShared": false,
    "mode": "snapshot",
    "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
    "rendererConfig": {},
    "rowIdColumn": "string",
    "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
    "shareRecipients": [
      {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      }
    ],
    "sharedBy": {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    },
    "status": "active",
    "storageKey": "string",
    "title": "string",
    "updatedAt": "2019-08-24T14:15:22Z",
    "viewerAccess": "owner"
  }
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Update Workspace

PATCH
/api/v1/workspaces/{workspace_id}

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

description?|
rendererConfig?|
title?|

Response Body

application/json

application/json

curl -X PATCH "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08" \  -H "Content-Type: application/json" \  -d '{}'
{
  "boundTasks": [
    {
      "bindingId": "5fecb7b6-229e-4247-b81d-92842fd7d9b7",
      "description": "string",
      "displayName": "string",
      "lifecycle": "draft",
      "mutatesWorkspace": true,
      "name": "string",
      "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8"
    }
  ],
  "workspace": {
    "backingOwnerTaskSlug": "string",
    "backingRowIdentityColumns": [
      "string"
    ],
    "backingSourceType": "string",
    "backingTableName": "string",
    "backingTableScope": "string",
    "backingWorkspaceKey": "string",
    "createdAt": "2019-08-24T14:15:22Z",
    "description": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "isShared": false,
    "mode": "snapshot",
    "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
    "rendererConfig": {},
    "rowIdColumn": "string",
    "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
    "shareRecipients": [
      {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      }
    ],
    "sharedBy": {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    },
    "status": "active",
    "storageKey": "string",
    "title": "string",
    "updatedAt": "2019-08-24T14:15:22Z",
    "viewerAccess": "owner"
  }
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Delete Workspace

DELETE
/api/v1/workspaces/{workspace_id}

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

curl -X DELETE "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08"
Empty
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

List Workspace Activity

GET
/api/v1/workspaces/{workspace_id}/activity

Path Parameters

workspace_id*string
Formatuuid

Query Parameters

limit?integer
Default50
Range1 <= value <= 200

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/activity"
{
  "items": [
    {
      "createdAt": "2019-08-24T14:15:22Z",
      "detail": {},
      "id": "string",
      "kind": "run",
      "status": "string",
      "title": "string"
    }
  ]
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Archive Workspace

POST
/api/v1/workspaces/{workspace_id}/archive

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X POST "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/archive"
{
  "boundTasks": [
    {
      "bindingId": "5fecb7b6-229e-4247-b81d-92842fd7d9b7",
      "description": "string",
      "displayName": "string",
      "lifecycle": "draft",
      "mutatesWorkspace": true,
      "name": "string",
      "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8"
    }
  ],
  "workspace": {
    "backingOwnerTaskSlug": "string",
    "backingRowIdentityColumns": [
      "string"
    ],
    "backingSourceType": "string",
    "backingTableName": "string",
    "backingTableScope": "string",
    "backingWorkspaceKey": "string",
    "createdAt": "2019-08-24T14:15:22Z",
    "description": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "isShared": false,
    "mode": "snapshot",
    "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
    "rendererConfig": {},
    "rowIdColumn": "string",
    "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
    "shareRecipients": [
      {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      }
    ],
    "sharedBy": {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    },
    "status": "active",
    "storageKey": "string",
    "title": "string",
    "updatedAt": "2019-08-24T14:15:22Z",
    "viewerAccess": "owner"
  }
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

List Workspace Charts

GET
/api/v1/workspaces/{workspace_id}/charts

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/charts"
{
  "items": [
    {
      "artifactId": "706a3f1e-c357-4634-b1bf-20c221b5bb4e",
      "chartSpecVersion": 0,
      "collapsed": true,
      "createdAt": "2019-08-24T14:15:22Z",
      "createdBy": "25a02396-1048-48f9-bf93-102d2fb7895e",
      "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
      "lastEditedBy": "c8f46d5a-a913-440d-93ff-c5119da72e7a",
      "position": 0,
      "rendererConfig": {},
      "spec": {
        "filters": [
          {}
        ],
        "group": {
          "column": "string"
        },
        "kind": "bar",
        "limit": 1000,
        "sort": {
          "by": "x",
          "order": "asc"
        },
        "subtitle": "string",
        "theme": "auto",
        "title": "string",
        "v": 1,
        "x": {
          "column": "string"
        },
        "y": [
          {
            "agg": "sum",
            "column": "string",
            "label": "string"
          }
        ]
      },
      "title": "string",
      "updatedAt": "2019-08-24T14:15:22Z",
      "workspaceId": "ef0efa32-d1c1-43d4-a5e2-fe7b4f00403c"
    }
  ]
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Create Workspace Chart

POST
/api/v1/workspaces/{workspace_id}/charts

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

spec*

Canonical VAI chart specification (v=1).

Stored in artifact_version.metadata["chart_spec"]. Compiled to ECharts option by chart_spec_compiler.

Response Body

application/json

application/json

curl -X POST "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/charts" \  -H "Content-Type: application/json" \  -d '{    "spec": {      "kind": "bar",      "x": {        "column": "string"      },      "y": [        {          "agg": "sum",          "column": "string"        }      ]    }  }'
{
  "artifactId": "706a3f1e-c357-4634-b1bf-20c221b5bb4e",
  "chartSpecVersion": 0,
  "collapsed": true,
  "createdAt": "2019-08-24T14:15:22Z",
  "createdBy": "25a02396-1048-48f9-bf93-102d2fb7895e",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "lastEditedBy": "c8f46d5a-a913-440d-93ff-c5119da72e7a",
  "position": 0,
  "rendererConfig": {},
  "spec": {
    "filters": [
      {}
    ],
    "group": {
      "column": "string"
    },
    "kind": "bar",
    "limit": 1000,
    "sort": {
      "by": "x",
      "order": "asc"
    },
    "subtitle": "string",
    "theme": "auto",
    "title": "string",
    "v": 1,
    "x": {
      "column": "string"
    },
    "y": [
      {
        "agg": "sum",
        "column": "string",
        "label": "string"
      }
    ]
  },
  "title": "string",
  "updatedAt": "2019-08-24T14:15:22Z",
  "workspaceId": "ef0efa32-d1c1-43d4-a5e2-fe7b4f00403c"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Get Workspace Chart

GET
/api/v1/workspaces/{workspace_id}/charts/{chart_id}

Path Parameters

workspace_id*string
Formatuuid
chart_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/charts/497f6eca-6276-4993-bfeb-53cbbbba6f08"
{
  "artifactId": "706a3f1e-c357-4634-b1bf-20c221b5bb4e",
  "chartSpecVersion": 0,
  "collapsed": true,
  "createdAt": "2019-08-24T14:15:22Z",
  "createdBy": "25a02396-1048-48f9-bf93-102d2fb7895e",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "lastEditedBy": "c8f46d5a-a913-440d-93ff-c5119da72e7a",
  "position": 0,
  "rendererConfig": {},
  "spec": {
    "filters": [
      {}
    ],
    "group": {
      "column": "string"
    },
    "kind": "bar",
    "limit": 1000,
    "sort": {
      "by": "x",
      "order": "asc"
    },
    "subtitle": "string",
    "theme": "auto",
    "title": "string",
    "v": 1,
    "x": {
      "column": "string"
    },
    "y": [
      {
        "agg": "sum",
        "column": "string",
        "label": "string"
      }
    ]
  },
  "title": "string",
  "updatedAt": "2019-08-24T14:15:22Z",
  "workspaceId": "ef0efa32-d1c1-43d4-a5e2-fe7b4f00403c"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Update Workspace Chart

PATCH
/api/v1/workspaces/{workspace_id}/charts/{chart_id}

Path Parameters

workspace_id*string
Formatuuid
chart_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

spec?|
specPatch?|

Response Body

application/json

application/json

curl -X PATCH "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/charts/497f6eca-6276-4993-bfeb-53cbbbba6f08" \  -H "Content-Type: application/json" \  -d '{}'
{
  "artifactId": "706a3f1e-c357-4634-b1bf-20c221b5bb4e",
  "chartSpecVersion": 0,
  "collapsed": true,
  "createdAt": "2019-08-24T14:15:22Z",
  "createdBy": "25a02396-1048-48f9-bf93-102d2fb7895e",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "lastEditedBy": "c8f46d5a-a913-440d-93ff-c5119da72e7a",
  "position": 0,
  "rendererConfig": {},
  "spec": {
    "filters": [
      {}
    ],
    "group": {
      "column": "string"
    },
    "kind": "bar",
    "limit": 1000,
    "sort": {
      "by": "x",
      "order": "asc"
    },
    "subtitle": "string",
    "theme": "auto",
    "title": "string",
    "v": 1,
    "x": {
      "column": "string"
    },
    "y": [
      {
        "agg": "sum",
        "column": "string",
        "label": "string"
      }
    ]
  },
  "title": "string",
  "updatedAt": "2019-08-24T14:15:22Z",
  "workspaceId": "ef0efa32-d1c1-43d4-a5e2-fe7b4f00403c"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Delete Workspace Chart

DELETE
/api/v1/workspaces/{workspace_id}/charts/{chart_id}

Path Parameters

workspace_id*string
Formatuuid
chart_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

curl -X DELETE "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/charts/497f6eca-6276-4993-bfeb-53cbbbba6f08"
Empty
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Query Workspace Chart Data

POST
/api/v1/workspaces/{workspace_id}/charts/{chart_id}/data

Path Parameters

workspace_id*string
Formatuuid
chart_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

filters?array<>

Response Body

application/json

application/json

curl -X POST "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/charts/497f6eca-6276-4993-bfeb-53cbbbba6f08/data" \  -H "Content-Type: application/json" \  -d '{}'
{
  "chartId": "54f93a91-b046-4439-9ec5-17949db5a60d",
  "groupColumn": "string",
  "rows": [
    {
      "group": {},
      "x": null,
      "y": 0
    }
  ],
  "truncated": false,
  "xColumn": "string",
  "yLabel": "string"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Update Workspace Chart Position

PATCH
/api/v1/workspaces/{workspace_id}/charts/{chart_id}/position

Path Parameters

workspace_id*string
Formatuuid
chart_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

position*integer
Range0 <= value

Response Body

application/json

application/json

curl -X PATCH "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/charts/497f6eca-6276-4993-bfeb-53cbbbba6f08/position" \  -H "Content-Type: application/json" \  -d '{    "position": 0  }'
{
  "artifactId": "706a3f1e-c357-4634-b1bf-20c221b5bb4e",
  "chartSpecVersion": 0,
  "collapsed": true,
  "createdAt": "2019-08-24T14:15:22Z",
  "createdBy": "25a02396-1048-48f9-bf93-102d2fb7895e",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "lastEditedBy": "c8f46d5a-a913-440d-93ff-c5119da72e7a",
  "position": 0,
  "rendererConfig": {},
  "spec": {
    "filters": [
      {}
    ],
    "group": {
      "column": "string"
    },
    "kind": "bar",
    "limit": 1000,
    "sort": {
      "by": "x",
      "order": "asc"
    },
    "subtitle": "string",
    "theme": "auto",
    "title": "string",
    "v": 1,
    "x": {
      "column": "string"
    },
    "y": [
      {
        "agg": "sum",
        "column": "string",
        "label": "string"
      }
    ]
  },
  "title": "string",
  "updatedAt": "2019-08-24T14:15:22Z",
  "workspaceId": "ef0efa32-d1c1-43d4-a5e2-fe7b4f00403c"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Get Workspace Data

GET
/api/v1/workspaces/{workspace_id}/data

Path Parameters

workspace_id*string
Formatuuid

Query Parameters

limit?integer
Default100
Range1 <= value <= 5000
offset?integer
Default0
Range0 <= value
sort_column?|
sort_direction?string

Sort direction for pagination.

Default"asc"
Value in"asc" | "desc"

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/data"
{
  "backingTableName": "string",
  "backingTableScope": "string",
  "canEdit": false,
  "columns": [
    {
      "dataType": "string",
      "displayName": "string",
      "name": "string"
    }
  ],
  "hasNext": true,
  "isLive": false,
  "items": [
    {}
  ],
  "limit": 0,
  "mode": "snapshot",
  "offset": 0,
  "readOnlyReason": "string",
  "rowIdentityColumns": [
    "string"
  ],
  "total": 0
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Update Workspace Cell

PATCH
/api/v1/workspaces/{workspace_id}/data/cells

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

column*string
Length1 <= length <= 255
expectedOldValue?|
newValue*|
rowIdentity?|
wsRowId?|

Response Body

application/json

application/json

curl -X PATCH "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/data/cells" \  -H "Content-Type: application/json" \  -d '{    "column": "string",    "newValue": {}  }'
{
  "mutationId": "07a10364-43fa-4ac9-ba37-9ba016453dbb",
  "row": {}
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Restore Workspace

POST
/api/v1/workspaces/{workspace_id}/restore

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X POST "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/restore"
{
  "boundTasks": [
    {
      "bindingId": "5fecb7b6-229e-4247-b81d-92842fd7d9b7",
      "description": "string",
      "displayName": "string",
      "lifecycle": "draft",
      "mutatesWorkspace": true,
      "name": "string",
      "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8"
    }
  ],
  "workspace": {
    "backingOwnerTaskSlug": "string",
    "backingRowIdentityColumns": [
      "string"
    ],
    "backingSourceType": "string",
    "backingTableName": "string",
    "backingTableScope": "string",
    "backingWorkspaceKey": "string",
    "createdAt": "2019-08-24T14:15:22Z",
    "description": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "isShared": false,
    "mode": "snapshot",
    "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
    "rendererConfig": {},
    "rowIdColumn": "string",
    "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
    "shareRecipients": [
      {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      }
    ],
    "sharedBy": {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    },
    "status": "active",
    "storageKey": "string",
    "title": "string",
    "updatedAt": "2019-08-24T14:15:22Z",
    "viewerAccess": "owner"
  }
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Get Workspace Run

GET
/api/v1/workspaces/{workspace_id}/runs/{run_id}

Path Parameters

workspace_id*string
Formatuuid
run_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/runs/497f6eca-6276-4993-bfeb-53cbbbba6f08"
{
  "completedAt": "2019-08-24T14:15:22Z",
  "context": {},
  "createdAt": "2019-08-24T14:15:22Z",
  "depth": 0,
  "error": "string",
  "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
  "observability": {
    "loadedSkillSlugs": [
      "string"
    ],
    "modelId": "string",
    "provider": "string",
    "traceProvider": "string",
    "usage": {
      "cacheWriteTokens": 0,
      "cachedInputTokens": 0,
      "inputTokens": 0,
      "outputTokens": 0,
      "totalCost": "string"
    }
  },
  "originRoomId": "2e579e6d-0364-4b50-80c4-a02472f9bbb8",
  "originRoomRunId": "ba21eb37-a75f-4035-bf67-ae4ed5202077",
  "originThreadId": "0b812833-7145-4cf2-b32f-34cb030a4d29",
  "outcome": {
    "artifactId": "string",
    "artifactName": "string",
    "rendererKind": "string",
    "rowCount": 0,
    "summary": "string",
    "version": 0
  },
  "parentRunId": "c21598d9-9e11-4929-a44f-027d54e71332",
  "result": {},
  "rootRunId": "9ebe2451-18c3-443e-8722-06064c27d8bb",
  "startedAt": "2019-08-24T14:15:22Z",
  "status": "string",
  "steps": [
    {
      "completedAt": "2019-08-24T14:15:22Z",
      "durationMs": 0,
      "error": "string",
      "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
      "input": {},
      "output": {},
      "sequence": 0,
      "sourceType": "string",
      "startedAt": "2019-08-24T14:15:22Z",
      "status": "string",
      "stepKey": "string",
      "toolCallId": "string",
      "toolName": "string"
    }
  ],
  "taskDisplayName": "string",
  "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8",
  "transcriptContent": "string",
  "transcriptRawData": {},
  "transcriptUpdatedAt": "2019-08-24T14:15:22Z",
  "triggerRef": "string",
  "triggeredBy": "string",
  "workflowDocumentId": "834c4967-5804-4c05-91f4-0493e12cb0c9",
  "workflowDocumentTitle": "string",
  "workflowDocumentVersion": 0,
  "workflowDocumentVersionId": "cf4a2665-88fb-4276-91c7-48bc9272334e",
  "workflowDocumentVersionLabel": "string",
  "workflowRuntimeSnapshot": {
    "document": {
      "capturedAt": "2019-08-24T14:15:22Z",
      "documentId": "4704590c-004e-410d-adf7-acb7ca0a7052",
      "documentVersion": 0,
      "documentVersionId": "d362740e-028b-4a92-841c-1ec552a1ee56",
      "documentVersionLabel": "string",
      "title": "string"
    },
    "kind": "workflow_runtime_snapshot"
  },
  "workspaceId": "ef0efa32-d1c1-43d4-a5e2-fe7b4f00403c"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

List Workspace Sessions

GET
/api/v1/workspaces/{workspace_id}/sessions

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/sessions"
{
  "items": [
    {
      "activeTurnId": "string",
      "activeTurnLastEventSeq": 0,
      "activeTurnStatus": "pending",
      "agentSpec": {
        "id": "string",
        "isDeleted": true,
        "lifecycleStatus": "active",
        "name": "string"
      },
      "agentSpecId": "string",
      "createdAt": "2019-08-24T14:15:22Z",
      "id": "string",
      "isShared": true,
      "lastTurnStatus": "pending",
      "scope": {
        "documentId": "string",
        "kind": "general",
        "workspaceId": "string"
      },
      "shareRecipients": [
        {
          "email": "string",
          "firstName": "string",
          "id": "string",
          "lastName": "string",
          "profilePictureUrl": "string"
        }
      ],
      "sharedBy": {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      },
      "title": "string",
      "updatedAt": "2019-08-24T14:15:22Z",
      "viewerAccess": "owner",
      "workspaceId": "string"
    }
  ]
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Create Workspace Session

POST
/api/v1/workspaces/{workspace_id}/sessions

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X POST "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/sessions"
{
  "activeTurnId": "string",
  "activeTurnLastEventSeq": 0,
  "activeTurnStatus": "pending",
  "agentSpec": {
    "id": "string",
    "isDeleted": true,
    "lifecycleStatus": "active",
    "name": "string"
  },
  "agentSpecId": "string",
  "createdAt": "2019-08-24T14:15:22Z",
  "id": "string",
  "isShared": true,
  "lastTurnStatus": "pending",
  "scope": {
    "documentId": "string",
    "kind": "general",
    "workspaceId": "string"
  },
  "shareRecipients": [
    {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    }
  ],
  "sharedBy": {
    "email": "string",
    "firstName": "string",
    "id": "string",
    "lastName": "string",
    "profilePictureUrl": "string"
  },
  "title": "string",
  "updatedAt": "2019-08-24T14:15:22Z",
  "viewerAccess": "owner",
  "workspaceId": "string"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

List Workspace Session Messages

GET
/api/v1/workspaces/{workspace_id}/sessions/{thread_id}/messages

Path Parameters

workspace_id*string
Formatuuid
thread_id*string
Formatuuid

Query Parameters

limit?integer
Default50
Range1 <= value <= 200
cursor?|

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/sessions/497f6eca-6276-4993-bfeb-53cbbbba6f08/messages"
{
  "items": [
    {
      "cancelled": false,
      "content": "string",
      "createdAt": "2019-08-24T14:15:22Z",
      "createdBy": "string",
      "durationSeconds": 0,
      "error": {
        "code": "string",
        "description": "string",
        "referenceId": "string",
        "retryable": true,
        "title": "string"
      },
      "format": "pydantic_ai",
      "id": "string",
      "rawData": {},
      "role": "user",
      "threadId": "string",
      "turnId": "string",
      "updatedAt": "2019-08-24T14:15:22Z"
    }
  ],
  "nextCursor": "string"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Get Workspace Share

GET
/api/v1/workspaces/{workspace_id}/share

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/share"
{
  "createdAt": "2019-08-24T14:15:22Z",
  "expiresAt": "2019-08-24T14:15:22Z",
  "recipientUserIds": [
    "string"
  ],
  "recipients": [
    {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    }
  ],
  "shareId": "string",
  "state": "not_shared",
  "status": "active",
  "updatedAt": "2019-08-24T14:15:22Z"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Revoke Workspace Share

DELETE
/api/v1/workspaces/{workspace_id}/share

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

curl -X DELETE "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/share"
Empty
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Upsert Workspace Share

PUT
/api/v1/workspaces/{workspace_id}/share

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

expiresAt?|
recipientUserIds?array<>

Response Body

application/json

application/json

curl -X PUT "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/share" \  -H "Content-Type: application/json" \  -d '{}'
{
  "createdAt": "2019-08-24T14:15:22Z",
  "expiresAt": "2019-08-24T14:15:22Z",
  "recipientUserIds": [
    "string"
  ],
  "recipients": [
    {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    }
  ],
  "shareId": "string",
  "state": "not_shared",
  "status": "active",
  "updatedAt": "2019-08-24T14:15:22Z"
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Clear Workspace Share

DELETE
/api/v1/workspaces/{workspace_id}/share/clear

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

curl -X DELETE "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/share/clear"
Empty
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

List Workspace Tags

GET
/api/v1/workspaces/{workspace_id}/tags

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

application/json

curl -X GET "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/tags"
{
  "items": [
    {
      "attributes": {},
      "color": "string",
      "createdAt": "2019-08-24T14:15:22Z",
      "description": "string",
      "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
      "name": "string",
      "namespace": "string",
      "slug": "string",
      "updatedAt": "2019-08-24T14:15:22Z"
    }
  ]
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Set Workspace Tags

PUT
/api/v1/workspaces/{workspace_id}/tags

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

tagIds?array<>
tagNames?array<>

Response Body

application/json

application/json

curl -X PUT "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/tags" \  -H "Content-Type: application/json" \  -d '{}'
{
  "items": [
    {
      "attributes": {},
      "color": "string",
      "createdAt": "2019-08-24T14:15:22Z",
      "description": "string",
      "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
      "name": "string",
      "namespace": "string",
      "slug": "string",
      "updatedAt": "2019-08-24T14:15:22Z"
    }
  ]
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Attach Task

POST
/api/v1/workspaces/{workspace_id}/tasks

Path Parameters

workspace_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

mutatesWorkspace?boolean
Defaultfalse
taskId*string
Formatuuid

Response Body

application/json

application/json

curl -X POST "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/tasks" \  -H "Content-Type: application/json" \  -d '{    "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8"  }'
{
  "boundTasks": [
    {
      "bindingId": "5fecb7b6-229e-4247-b81d-92842fd7d9b7",
      "description": "string",
      "displayName": "string",
      "lifecycle": "draft",
      "mutatesWorkspace": true,
      "name": "string",
      "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8"
    }
  ],
  "workspace": {
    "backingOwnerTaskSlug": "string",
    "backingRowIdentityColumns": [
      "string"
    ],
    "backingSourceType": "string",
    "backingTableName": "string",
    "backingTableScope": "string",
    "backingWorkspaceKey": "string",
    "createdAt": "2019-08-24T14:15:22Z",
    "description": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "isShared": false,
    "mode": "snapshot",
    "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
    "rendererConfig": {},
    "rowIdColumn": "string",
    "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
    "shareRecipients": [
      {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      }
    ],
    "sharedBy": {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    },
    "status": "active",
    "storageKey": "string",
    "title": "string",
    "updatedAt": "2019-08-24T14:15:22Z",
    "viewerAccess": "owner"
  }
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Update Task Binding

PATCH
/api/v1/workspaces/{workspace_id}/tasks/{task_id}

Path Parameters

workspace_id*string
Formatuuid
task_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Request Body

application/json

mutatesWorkspace*boolean

Response Body

application/json

application/json

curl -X PATCH "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/tasks/497f6eca-6276-4993-bfeb-53cbbbba6f08" \  -H "Content-Type: application/json" \  -d '{    "mutatesWorkspace": true  }'
{
  "boundTasks": [
    {
      "bindingId": "5fecb7b6-229e-4247-b81d-92842fd7d9b7",
      "description": "string",
      "displayName": "string",
      "lifecycle": "draft",
      "mutatesWorkspace": true,
      "name": "string",
      "taskId": "e6e9d88a-9b63-468a-aec3-b7a11de27af8"
    }
  ],
  "workspace": {
    "backingOwnerTaskSlug": "string",
    "backingRowIdentityColumns": [
      "string"
    ],
    "backingSourceType": "string",
    "backingTableName": "string",
    "backingTableScope": "string",
    "backingWorkspaceKey": "string",
    "createdAt": "2019-08-24T14:15:22Z",
    "description": "string",
    "id": "497f6eca-6276-4993-bfeb-53cbbbba6f08",
    "isShared": false,
    "mode": "snapshot",
    "ownerUserId": "283eeac5-beea-465a-80a5-763009480d0f",
    "rendererConfig": {},
    "rowIdColumn": "string",
    "seedArtifactVersionId": "47eac984-0299-4764-b56f-651e5a70b796",
    "shareRecipients": [
      {
        "email": "string",
        "firstName": "string",
        "id": "string",
        "lastName": "string",
        "profilePictureUrl": "string"
      }
    ],
    "sharedBy": {
      "email": "string",
      "firstName": "string",
      "id": "string",
      "lastName": "string",
      "profilePictureUrl": "string"
    },
    "status": "active",
    "storageKey": "string",
    "title": "string",
    "updatedAt": "2019-08-24T14:15:22Z",
    "viewerAccess": "owner"
  }
}
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}

Delete Task Binding

DELETE
/api/v1/workspaces/{workspace_id}/tasks/{task_id}

Path Parameters

workspace_id*string
Formatuuid
task_id*string
Formatuuid

Header Parameters

authorization?|
X-API-Key?|
vai_token?|

Response Body

application/json

curl -X DELETE "https://loading/api/v1/workspaces/497f6eca-6276-4993-bfeb-53cbbbba6f08/tasks/497f6eca-6276-4993-bfeb-53cbbbba6f08"
Empty
{
  "detail": [
    {
      "loc": [
        "string"
      ],
      "msg": "string",
      "type": "string"
    }
  ]
}